<?php

declare(strict_types=1);

namespace Dedi\SyliusContactPlugin\Controller\Admin;

use Dedi\SyliusContactPlugin\Repository\ContactFormMessageRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

class ShowMessageAction extends AbstractController
{
    private ContactFormMessageRepository $repository;

    public function __construct(ContactFormMessageRepository $repository)
    {
        $this->repository = $repository;
    }

    public function __invoke(Request $request): Response
    {
        $template = $this->getSyliusAttribute(
            $request,
            'template',
            '@DediSyliusContactPlugin/Admin/ContactFormMessage/show.html.twig'
        );

        $message = $this->repository->find($request->attributes->getInt('id'));

        return $this->render($template, ['message' => $message]);
    }

    private function getSyliusAttribute(Request $request, string $attributeName, ?string $default): ?string
    {
        $attributes = $request->attributes->get('_sylius');

        return $attributes[$attributeName] ?? $default;
    }
}
